package com.okooo.osgi.rpc;

import org.apache.xmlrpc.XmlRpcException;
import org.apache.xmlrpc.XmlRpcRequest;
import org.apache.xmlrpc.server.RequestProcessorFactoryFactory;
/**
 * 
 * @author jiangyubao@gmail.com
 * 
 */
public class MyRequestProcessorFactoryFactory implements
		RequestProcessorFactoryFactory {
	private Object processor = null;

	protected Object getRequestProcessor(Class pClass) throws XmlRpcException {
		try {
			Object obj = Activator.getInstance().getService(pClass);
			if (obj == null) {
				throw new Exception("osgi service object null");
			} else {
				return obj;
			}
		} catch (InstantiationException e) {
			throw new XmlRpcException("Failed to instantiate class "
					+ pClass.getName(), e);
		} catch (IllegalAccessException e) {
			throw new XmlRpcException(
					"Illegal access when instantiating class "
							+ pClass.getName(), e);
		} catch (Exception e) {
			e.printStackTrace();
			throw new XmlRpcException("OSGi service not found exception "
					+ pClass.getName(), e);
		}
	}

	public RequestProcessorFactory getRequestProcessorFactory(Class pClass)
			throws XmlRpcException {
		processor = this.getRequestProcessor(pClass);
		return new RequestProcessorFactory() {
			public Object getRequestProcessor(XmlRpcRequest pRequest)
					throws XmlRpcException {
				return processor;
			}
		};
	}
}
