package com.okooo.osgi.rpc.service.impl;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.xmlrpc.XmlRpcException;
import org.osgi.framework.ServiceEvent;
import org.osgi.framework.ServiceListener;

import com.okooo.osgi.rpc.Activator;
import com.okooo.osgi.rpc.service.IRpcExporterService;

/**
 * 
 * @author jiangyubao@gmail.com
 * 
 */
public class RpcExporterServiceImpl implements IRpcExporterService {
	protected Log logger = LogFactory.getLog(RpcExporterServiceImpl.class);

	@Override
	public boolean exportByListener(final String key, final Class clazz) {
		try {
			Activator.getInstance().getContext().addServiceListener(
					new ServiceListener() {
						@Override
						public void serviceChanged(ServiceEvent event) {
							try {
								Activator.getInstance()
										.getPropertyHandlerMapping()
										.addHandler(key, clazz);
							} catch (XmlRpcException e) {
								e.printStackTrace();
								logger.error("", e);
							}
						}
					}, "(objectClass=" + clazz.getName() + ")");
			return true;
		} catch (Exception e) {
			logger.error("", e);
			return false;
		}

	}

	@Override
	public boolean export(final String key, final Class clazz) {
		try {
			Activator.getInstance().getPropertyHandlerMapping().addHandler(key,
					clazz);
			System.out.println("export " + key + " " + clazz.getName());
			return true;
		} catch (XmlRpcException e) {
			e.printStackTrace();
			logger.error("", e);
			return false;
		}
	}

	@Override
	public void unexport(final String key) {
		Activator.getInstance().getPropertyHandlerMapping().removeHandler(key);

	}

}
